// Geometry file for the flow over step


//     ^ Oy                      
//     |                            (5)
//     6---------------------------------------------------------------------5
//     |                                                                     |
// (6) |                                                                     |
//     |                                                                     |
//     |                                                                     | (4)
//     |                                                                     |
//     1--------------------------2                                          |
//               (1)              |                                          |
//                            (2) |                                          |
//                                3------------------------------------------4 --> Ox
//                                                (3)

l = 3;
L = 7;
H = 1;
HH = 3;
h = 0.1;

Point(1) = {0.0,   H, 0.0, h};
Point(2) = {  l,   H, 0.0, h};
Point(3) = {  l, 0.0, 0.0, h};
Point(4) = {l+L, 0.0, 0.0, h};
Point(5) = {l+L,  HH, 0.0, h};
Point(6) = {  0,  HH, 0.0, h};

Line(1) = {1,2};
Line(2) = {2,3};
Line(3) = {3,4};
Line(4) = {4,5};
Line(5) = {5,6};
Line(6) = {6,1};

Line Loop(1) = {1,2,3,4,5,6};

Plane Surface(10) = {1};
Physical Surface(1) = {10};

Physical Line(11) = {1,2,3,5};
Physical Line(21) = {6};
Physical Line(1) = {4};
