// ********** DO NOT REMOVE THIS BANNER **********
//
// SUMMARY: Bamg: Bidimensional Anisotrope Mesh Generator
// RELEASE: 0 
// USAGE  : You may copy freely these files and use it for    
//          teaching or research. These or part of these may   
//          not be sold or used for a commercial purpose with- 
//          out our consent : fax (33) 1 39 63 55 14       
//
// AUTHOR:   F. Hecht,    
// ORG    :  INRIA
// E-MAIL :   Frederic.Hecht@Inria.fr   
//
// ORIG-DATE:     Dec 97

#ifndef _SetOfEdge4_h
#define _SetOfEdge4_h

namespace bamg {

class SetOfEdges4;

class Int4Edge{

 friend class SetOfEdges4;

 public:
  Int4 i, j, next; 

};


class SetOfEdges4 {

  Int4 nx, nbax, NbOfEdges, *_head;
  Int4Edge *_edges;

 public:

  SetOfEdges4(Int4,
              Int4);

  ~SetOfEdges4() {
     delete [] _head;
     delete [] _edges;
  }

  Int4 add (Int4 ii,
            Int4 jj);

  Int4 addtrie (Int4 ii,
                Int4 jj)
  { return ii <=jj ? add(ii,jj) : add(jj,ii); }

  Int4 nb() const { return NbOfEdges; }

  Int4 find(Int4 ii,
            Int4 jj) const;

  Int4 findtrie(Int4 ii,
                Int4 jj)
  { return ii <=jj ? find(ii,jj) : find(jj,ii); }

  Int4 i(Int4 k) const { return _edges[k].i; }

  Int4 j(Int4 k) const { return _edges[k].j; }

  Int4 newarete(Int4 k) const { return NbOfEdges == k+1; }

  Int4Edge& operator[](Int4 k) const { return _edges[k]; }
};

}

#endif 
