#include <iostream> 
using namespace std;

#include "mesh/bamg/meshtype.h"
#include "mesh/bamg/SetOfE4.h"

namespace bamg {

SetOfEdges4::SetOfEdges4(Int4 mmx,
                         Int4 nnx)
{
   nx = nnx;
   nbax = mmx;
   NbOfEdges = 0;
   _head = new Int4 [nx];
   Int4 i=nx;
   while (i--)
      _head[i] = -1;
   _edges = new Int4Edge[nbax];
}

    
Int4 SetOfEdges4::find(Int4 ii,
                       Int4 jj) const
{
   if (_head==NULL) {
      cerr <<"SetOfEdges4::find \nNo more heap head\n";
      MeshError(888);
   }
   Int4 n = _head[Abs(ii) % nx];

   while (n >= 0) 
      if (ii==_edges[n].i && jj==_edges[n].j)
         return n;
      else
         n = _edges[n].next;
   return -1;
}


Int4 SetOfEdges4::add(Int4 ii,
                      Int4 jj)
{
   if (_head==NULL) {
      cerr << "SetOfEdges4::add\nNo more heap head" << endl;
      MeshError(888);
   }

   Int4 h, n=_head[h=Abs(ii) % nx];
   while (n >= 0) { 
      if (ii==_edges[n].i && jj==_edges[n].j)
         return n;
      else
         n = _edges[n].next;
   }
   if (nbax <=NbOfEdges ) {
      cerr << " SetOfEdges4::add\nHeap overflow " << nbax << " " << NbOfEdges << endl;
      MeshError(888);
   }
   _edges[NbOfEdges].i = ii;
   _edges[NbOfEdges].j = jj;
   _edges[NbOfEdges].next = _head[h];
   _head[h] = NbOfEdges;
   return NbOfEdges++;
}

}  // end of namespace bamg 
